-- You may use and modify this file free
-- without deleting this comment group
-- Copyright (c) 1998 Dimitriy Anisimkov
-- e-mail anisimkov@yahoo.com
-- phone +7 (381)-2-217774
with ADA.Finalization;
generic
  type Static (<>) is private;
  NullValue : Static;
package Dynamic_Controlled is 

   type Dynamic is private;
   type Static_Access is access all Static;

   function Create(Acc : in Static) return Dynamic;
   function GetAccess(from : Dynamic) return Static_Access;
   
   generic
      with function Operator(A1,A2 : in Static) return Static;
   function Binary_Operator(D1,D2 : in Dynamic) return Dynamic;

   generic
      with function Comp(A1,A2 : in Static) return Boolean;
   function Compare(D1,D2 : in Dynamic) return Boolean;
   
   generic 
     type Alien (<>) is private;
     with function AlienSecondParam(A : Static;S : Alien) return Static;
   function AlienSecond(A : Dynamic;S : Alien) return Dynamic;
        
   generic 
     with function Unary_Stat(A : Static) return Static;
   function Unary(A : Dynamic) return Dynamic;
   
   pragma inline(Compare,GetAccess);
   
--  pragma inline(Create,Binary_Operator,Unary);
--  this pragma commented becouse produce error under Aonix adacomp 7.1.424
   
private

   subtype Auto is ADA.Finalization.Controlled;

   type Dynamic is new Auto with 
   record
      Refer : Static_Access;
   end record;
   
   procedure Initialize(Object : in out Dynamic);   
   procedure Adjust(Object : in out Dynamic);
   procedure Finalize  (Object : in out Dynamic);

end;