-- Unlimited numbers dynamic implementation
-- You may free use and modify this file 
-- without deleting this comment group
-- Copyright (c) 1998 Dimitriy Anisimkov
-- e-mail anisimkov@yahoo.com
-- phone +7 (381)-2-217774
with Unlimited.Number,Dynamic_Controlled;
use Unlimited.Number;
package Unlimited.Dynamic is

   package DynUnlim is new Dynamic_Controlled(Unlimited_Static,Nil);
   subtype Unbounded_Number is DynUnlim.Dynamic;
   function "+" is new DynUnlim.Binary_Operator("+");
   function "-" is new DynUnlim.Binary_Operator("-");
   function "*" is new DynUnlim.Binary_Operator("*");
   function "/" is new DynUnlim.Binary_Operator("/");
   function "and" is new DynUnlim.Binary_Operator("and");
   function "or" is new DynUnlim.Binary_Operator("or");
   function "xor" is new DynUnlim.Binary_Operator("xor");
   function "rem" is new DynUnlim.Binary_Operator("rem");
   function "<" is new DynUnlim.Compare("<");
   function ">" is new DynUnlim.Compare(">");
   function "<=" is new DynUnlim.Compare("<=");
   function ">=" is new DynUnlim.Compare(">=");
   -- this renaming only to avoid bug founded in AONIX build 7.1.424
   function Equal4Aonix is new DynUnlim.Compare("=");
   function "="(u1,u2 : Unbounded_Number) return boolean renames Equal4Aonix;
--   function "=" is new DynUnlim.Compare("=");
   function Shift is new DynUnlim.AlienSecond(Integer,Shift);
   function "*" is new DynUnlim.AlienSecond(Int,"*");
   function "/" is new DynUnlim.AlienSecond(Int,"/");
   function "rem" is new DynUnlim.AlienSecond(Int,"rem");
   function "-" is new DynUnlim.Unary("-");
   function "abs" is new DynUnlim.Unary("abs");
   
   procedure Divide(Numerator,Denominator : in Unbounded_Number;
         Result,Remainder : out Unbounded_Number);
   function To_String(Num : in Unbounded_Number; 
         Base : Base_Of_Presentation :=10) return String;
   function To_String(Num : in Unbounded_Number; 
         Base : Conversion_Chars) return String;
   Wrong_Symbol : exception;
   function To_Unbounded_Number(S : String) return Unbounded_Number;
   nil : Unbounded_Number := DynUnlim.Create((0=>0));
   one : Unbounded_Number := DynUnlim.Create((0=>1));
   
--   pragma inline(Divide);

end Unlimited.Dynamic;